package com.mysema.commons.web;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;

public class CookieFilter implements Filter {

     public void doFilter(ServletRequest req, ServletResponse res,
             FilterChain chain) throws ServletException, IOException {
                  
         if (req.isSecure() && req instanceof HttpServletRequest) {
             HttpServletRequest httpReq = (HttpServletRequest) req;
             HttpServletResponse httpRes = (HttpServletResponse) res;

             Cookie[] cookies = httpReq.getCookies();
             if (cookies != null && cookies.length > 0) {
                 for (Cookie cookie : cookies) {
                     if (!cookie.getSecure()){
                         cookie.setSecure(true);
                         httpRes.addCookie(cookie);    
                     }                     
                 }
             }
             
             HttpServletResponse resWrapper = new HttpServletResponseWrapper(httpRes){
                 @Override
                 public void addCookie(Cookie cookie) {
                     cookie.setSecure(true);
                     super.addCookie(cookie);
                 }
             };
             
             chain.doFilter(req, resWrapper);
             
         }else{
         
             chain.doFilter(req, res);
             
         }
         
     }
     
     public void init(FilterConfig arg0) throws ServletException {
     }


     public void destroy() {
     }

 }