/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.web;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Locale;

/**
 * A provides
 *
 * @author tiwe
 * @version $Id$
 */
public final class IPUtil {
	
	private IPUtil(){}
    
    public static Locale getLocaleForAddress(String ip, Locale defaultLocale) throws UnknownHostException{
        byte[] b = new byte[4];
        String[] bytes = ip.split("[.]");
        for (int i = 0; i < bytes.length; i++)
        {
            b[i] = new Integer(bytes[i]).byteValue();
        }
        InetAddress addr = InetAddress.getByAddress(b);
        if (!addr.getHostAddress().equals(addr.getHostName())){
            String host = addr.getHostName();
            String tld = host.substring(host.lastIndexOf('.')+1);
            return new Locale(tld);    
        }
        return defaultLocale;
    }
    
}
